accessKey
The value of this option will be passed to the accesskey
attribute of the HTML element that underlies the widget.
activeStateEnabled
A Boolean value specifying whether or not the widget changes its state when interacting with a user.
adaptivityEnabled
Specifies whether adaptive widget rendering is enabled on small screens. Applies only if the orientation is "horizontal".
On small-screen devices, the Menu is shown as a list icon, and items have a tree structure like the TreeView items if adaptive rendering is enabled.
animation
dataSource
If you use DevExtreme ASP.NET MVC Controls, refer to the Data Binding article.
The Menu works with collections of string
values or objects.
Depending on your data source, bind the Menu to data as follows. If the data source provides objects, also specify the itemTemplate. You can skip this part if the objects contain fields described in the Default Item Template section.
Data Array
Assign the array to the dataSource option.Read-Only Data in JSON Format
Set the dataSource option to the URL of a JSON file or service that returns JSON data.OData
Implement an ODataStore.Web API, PHP, MongoDB
Use one of the following extensions to enable the server to process data according to the protocol DevExtreme widgets use:Then, use the createStore method to configure access to the server on the client as shown below. This method is part of DevExtreme.AspNet.Data.
app.component.tsapp.component.htmlapp.module.ts- import { Component } from '@angular/core';
- import CustomStore from 'devextreme/data/custom_store';
- import { createStore } from 'devextreme-aspnet-data-nojquery';
- @Component({
- selector: 'app-root',
- templateUrl: './app.component.html',
- styleUrls: ['./app.component.css']
- })
- export class AppComponent {
- store: CustomStore;
- constructor() {
- let serviceUrl = "https://url/to/my/service";
- this.store = createStore({
- key: "ID",
- loadUrl: serviceUrl + "/GetAction",
- insertUrl: serviceUrl + "/InsertAction",
- updateUrl: serviceUrl + "/UpdateAction",
- deleteUrl: serviceUrl + "/DeleteAction"
- })
- }
- }
- <dx-menu ...
- [dataSource]="store">
- </dx-menu>
- import { BrowserModule } from '@angular/platform-browser';
- import { NgModule } from '@angular/core';
- import { AppComponent } from './app.component';
- import { DxMenuModule } from 'devextreme-angular';
- @NgModule({
- declarations: [
- AppComponent
- ],
- imports: [
- BrowserModule,
- DxMenuModule
- ],
- providers: [],
- bootstrap: [AppComponent]
- })
- export class AppModule { }
Any other data source
Implement a CustomStore.
Regardless of the data source on the input, the Menu always wraps it in the DataSource object. This object allows you to sort, filter, group, and otherwise shape data. To get its instance, call the getDataSource() method.
Please review the following notes about data binding:
Do not specify the items option if you specified the dataSource, and vice versa.
Data field names should not contain the following characters:
.
,,
,:
,[
, and]
.DataSource and stores provide methods to process and update data. However, the methods do not allow you to perform particular tasks (for example, replace the entire dataset, reconfigure data access at runtime). For such tasks, create a new array, store, or DataSource and assign it to the dataSource option as shown in the articles about changing options in jQuery, Angular, React, and Vue.
disabledExpr
Specifies the name of the data source item field whose value defines whether or not the corresponding widget item is disabled.
displayExpr
Set this option to the name of a data field that provides displayed values...
- displayExpr: "name"
... or to a function that combines the values of several data fields to create the displayed value:
- displayExpr: function(item) {
- // "item" can be null
- return item && 'ID: ' + item.id + ', Name: ' + item.name;
- }
elementAttr
Specifies the attributes to be attached to the widget's root element.
height
This option accepts a value of one of the following types:
Number
The height in pixels.String
A CSS-accepted measurement of height. For example,"55px"
,"80%"
,"auto"
,"inherit"
.Function
A function returning either of the above. For example:JavaScript- height: function() {
- return window.innerHeight / 1.5;
- }
items
To display menu items, a default template can be used. This template is based on certain fields of the item object. Refer to the Default Item Template section to learn which fields are taken into account when creating a default template for items. Alternatively, you can implement a custom item template.
onContentReady
A function that is executed when the widget's content is ready and each time the content is changed.
Name | Type | Description |
---|---|---|
component |
The widget's instance. |
|
element |
The widget's container. It is an HTML Element or a jQuery Element when you use jQuery. |
|
model |
The model data. Available only when using Knockout. |
onDisposing
A function that is executed before the widget is disposed of.
Name | Type | Description |
---|---|---|
component |
The widget's instance. |
|
element |
The widget's container. It is an HTML Element or a jQuery Element when you use jQuery. |
|
model |
The model data. Available only if you use Knockout. |
onInitialized
Name | Type | Description |
---|---|---|
component |
The widget's instance. |
|
element |
The widget's container. It is an HTML Element or a jQuery Element when you use jQuery. |
onItemClick
Name | Type | Description |
---|---|---|
component |
The widget's instance. |
|
element |
The widget's container. |
|
model |
The model data. Available only if you use Knockout. |
|
itemData |
The clicked item's data. |
|
itemElement |
The item's container. It is an HTML Element or a jQuery Element when you use jQuery. |
|
itemIndex |
The clicked item's index. |
|
jQueryEvent |
Use 'event' instead. The jQuery event that caused the handler execution. Deprecated in favor of the event field. |
|
event | Event (jQuery or EventObject) |
The event that caused the handler execution. It is a dxEvent or a jQuery.Event when you use jQuery. |
onItemContextMenu
Name | Type | Description |
---|---|---|
component |
The widget's instance. |
|
element |
The widget's container. It is an HTML Element or a jQuery Element when you use jQuery. |
|
model |
The model data. Available only if you use Knockout. |
|
itemData |
The item's data. |
|
itemElement |
The item's container. It is an HTML Element or a jQuery Element when you use jQuery. |
|
itemIndex |
The item's index. |
|
jQueryEvent |
Use 'event' instead. The jQuery event that caused the handler execution. Deprecated in favor of the event field. |
|
event | Event (jQuery or EventObject) |
The event that caused the handler execution. It is a dxEvent or a jQuery.Event when you use jQuery. |
onItemRendered
Name | Type | Description |
---|---|---|
component |
The widget's instance. |
|
element |
The widget's container. It is an HTML Element or a jQuery Element when you use jQuery. |
|
model |
The model data. Available only if you use Knockout. |
|
itemData |
The current item's data. |
|
itemElement |
The item's container. It is an HTML Element or a jQuery Element when you use jQuery. |
|
itemIndex |
The current item's index. |
onOptionChanged
Name | Type | Description |
---|---|---|
name |
The modified option if it belongs to the first level. Otherwise, the first-level option it is nested into. |
|
model |
The model data. Available only if you use Knockout. |
|
element |
The widget's container. It is an HTML Element or a jQuery Element when you use jQuery. |
|
component |
The widget's instance. |
|
fullName |
The path to the modified option that includes all parent options. |
|
value | any |
The modified option's new value. |
onSelectionChanged
Name | Type | Description |
---|---|---|
component |
The widget's instance. |
|
element |
The widget's container. It is an HTML Element or a jQuery Element when you use jQuery. |
|
model |
The model data. Available only if you use Knockout. |
|
addedItems | Array<any> |
The data of the items that have been selected. |
removedItems | Array<any> |
The data of the items whose selection has been canceled. |
onSubmenuHidden
Name | Type | Description |
---|---|---|
component |
The widget's instance. |
|
element |
The widget's container. It is an HTML Element or a jQuery Element when you use jQuery. |
|
model |
The model data. Available only if Knockout is used. |
|
rootItem |
The container of the root menu element. It is an HTML Element or a jQuery Element when you use jQuery. |
onSubmenuHiding
Name | Type | Description |
---|---|---|
component |
The widget's instance. |
|
element |
The widget's container. It is an HTML Element or a jQuery Element when you use jQuery. |
|
model |
The model data. Available only if Knockout is used. |
|
rootItem |
The container of the root menu element. It is an HTML Element or a jQuery Element when you use jQuery. |
|
cancel |
Allows you to cancel submenu hiding. |
onSubmenuShowing
Name | Type | Description |
---|---|---|
component |
The widget's instance. |
|
element |
The widget's container. It is an HTML Element or a jQuery Element when you use jQuery. |
|
model |
The model data. Available only if Knockout is used. |
|
rootItem |
The container of the root menu element. It is an HTML Element or a jQuery Element when you use jQuery. |
onSubmenuShown
Name | Type | Description |
---|---|---|
component |
The widget's instance. |
|
element |
The widget's container. It is an HTML Element or a jQuery Element when you use jQuery. |
|
model |
The model data. Available only if Knockout is used. |
|
rootItem |
The container of the root menu element. It is an HTML Element or a jQuery Element when you use jQuery. |
orientation
Use the Orientation
enum to specify this option when the widget is used as an ASP.NET MVC Control. This enum accepts the following values: Horizontal
and Vertical
.
rtlEnabled
When this option is set to true, the widget text flows from right to left, and the layout of elements is reversed. To switch the entire application/site to the right-to-left representation, assign true to the rtlEnabled field of the object passed to the DevExpress.config(config) method.
- DevExpress.config({
- rtlEnabled: true
- });
See Also
- Right-to-Left Support Demo: DataGrid | Navigation Widgets | Editors
selectedExpr
Specifies the name of the data source item field whose value defines whether or not the corresponding widget items is selected.
selectionMode
To select an item on click and to visually display the selection, set the selectByClick option to true. Note that in this case the selectionMode should be "single".
Use the MenuSelectionMode
enum to specify this option when the widget is used as an ASP.NET MVC Control. This enum accepts the following values: Single
and None
.
showFirstSubmenuMode
If you assign a string that specifies the mode name to this option, the widget will use the default delay value.
- showFirstSubmenuMode: "onHover"
Use the ShowSubmenuMode
enum to specify this option when the widget is used as an ASP.NET MVC Control. This enum accepts the following values: OnHover
and OnClick
.
showSubmenuMode
By default, the secondary-level submenus of the Menu widget are displayed on the same event as the first-level submenu. To set another event for displaying secondary-level submenus, use the showSubmenuMode option. Alternatively, you can change the event on which the first-level submenu is displayed. For this purpose, use the showFirstSubmenuMode option.
Use the ShowSubmenuMode
enum to specify this option when the widget is used as an ASP.NET MVC Control. This enum accepts the following values: OnHover
and OnClick
.
submenuDirection
By default, the first submenu is displayed so that it is visible totally, based on the menu location on the page. Use the submenuDirection option to display the first submenu at the bottom or at the top of a root item when the widget's orientation is horizontal, and to the left or to the right when orientation is vertical.
Use the SubmenuDirection
enum to specify this option when the widget is used as an ASP.NET MVC Control. This enum accepts the following values: LeftOrTop
, RightOrBottom
, and Auto
.
tabIndex
The value of this option will be passed to the tabindex
attribute of the HTML element that underlies the widget.
width
This option accepts a value of one of the following types:
Number
The width in pixels.String
A CSS-accepted measurement of width. For example,"55px"
,"80%"
,"auto"
,"inherit"
.Function
A function returning either of the above. For example:JavaScript- width: function() {
- return window.innerWidth / 1.5;
- }
If you have technical questions, please create a support ticket in the DevExpress Support Center.

accessKey
The value of this option will be passed to the accesskey
attribute of the HTML element that underlies the widget.
activeStateEnabled
A Boolean value specifying whether or not the widget changes its state when interacting with a user.
adaptivityEnabled
Specifies whether adaptive widget rendering is enabled on small screens. Applies only if the orientation is "horizontal".
On small-screen devices, the Menu is shown as a list icon, and items have a tree structure like the TreeView items if adaptive rendering is enabled.
animation
dataSource
If you use DevExtreme ASP.NET MVC Controls, refer to the Data Binding article.
The Menu works with collections of string
values or objects.
Depending on your data source, bind the Menu to data as follows. If the data source provides objects, also specify the itemTemplate. You can skip this part if the objects contain fields described in the Default Item Template section.
Data Array
Assign the array to the dataSource option.Read-Only Data in JSON Format
Set the dataSource option to the URL of a JSON file or service that returns JSON data.OData
Implement an ODataStore.Web API, PHP, MongoDB
Use one of the following extensions to enable the server to process data according to the protocol DevExtreme widgets use:Then, use the createStore method to configure access to the server on the client as shown below. This method is part of DevExtreme.AspNet.Data.
App.js- import React from 'react';
- import 'devextreme/dist/css/dx.common.css';
- import 'devextreme/dist/css/dx.light.css';
- import CustomStore from 'devextreme/data/custom_store';
- import { createStore } from 'devextreme-aspnet-data-nojquery';
- import Menu from 'devextreme-react/menu';
- const serviceUrl = "https://url/to/my/service";
- const store = createStore({
- key: "ID",
- loadUrl: serviceUrl + "/GetAction",
- insertUrl: serviceUrl + "/InsertAction",
- updateUrl: serviceUrl + "/UpdateAction",
- deleteUrl: serviceUrl + "/DeleteAction"
- });
- class App extends React.Component {
- render() {
- return (
- <Menu ...
- dataSource={store} />
- );
- }
- }
- export default App;
Any other data source
Implement a CustomStore.
Regardless of the data source on the input, the Menu always wraps it in the DataSource object. This object allows you to sort, filter, group, and otherwise shape data. To get its instance, call the getDataSource() method.
Please review the following notes about data binding:
Do not specify the items option if you specified the dataSource, and vice versa.
Data field names should not contain the following characters:
.
,,
,:
,[
, and]
.DataSource and stores provide methods to process and update data. However, the methods do not allow you to perform particular tasks (for example, replace the entire dataset, reconfigure data access at runtime). For such tasks, create a new array, store, or DataSource and assign it to the dataSource option as shown in the articles about changing options in jQuery, Angular, React, and Vue.
disabledExpr
Specifies the name of the data source item field whose value defines whether or not the corresponding widget item is disabled.
displayExpr
Set this option to the name of a data field that provides displayed values...
- displayExpr: "name"
... or to a function that combines the values of several data fields to create the displayed value:
- displayExpr: function(item) {
- // "item" can be null
- return item && 'ID: ' + item.id + ', Name: ' + item.name;
- }
elementAttr
Specifies the attributes to be attached to the widget's root element.
height
This option accepts a value of one of the following types:
Number
The height in pixels.String
A CSS-accepted measurement of height. For example,"55px"
,"80%"
,"auto"
,"inherit"
.Function
A function returning either of the above. For example:JavaScript- height: function() {
- return window.innerHeight / 1.5;
- }
items
To display menu items, a default template can be used. This template is based on certain fields of the item object. Refer to the Default Item Template section to learn which fields are taken into account when creating a default template for items. Alternatively, you can implement a custom item template.
onContentReady
A function that is executed when the widget's content is ready and each time the content is changed.
Name | Type | Description |
---|---|---|
component |
The widget's instance. |
|
element |
The widget's container. It is an HTML Element or a jQuery Element when you use jQuery. |
|
model |
The model data. Available only when using Knockout. |
onDisposing
A function that is executed before the widget is disposed of.
Name | Type | Description |
---|---|---|
component |
The widget's instance. |
|
element |
The widget's container. It is an HTML Element or a jQuery Element when you use jQuery. |
|
model |
The model data. Available only if you use Knockout. |
onInitialized
Name | Type | Description |
---|---|---|
component |
The widget's instance. |
|
element |
The widget's container. It is an HTML Element or a jQuery Element when you use jQuery. |
onItemClick
Name | Type | Description |
---|---|---|
component |
The widget's instance. |
|
element |
The widget's container. |
|
model |
The model data. Available only if you use Knockout. |
|
itemData |
The clicked item's data. |
|
itemElement |
The item's container. It is an HTML Element or a jQuery Element when you use jQuery. |
|
itemIndex |
The clicked item's index. |
|
jQueryEvent |
Use 'event' instead. The jQuery event that caused the handler execution. Deprecated in favor of the event field. |
|
event | Event (jQuery or EventObject) |
The event that caused the handler execution. It is a dxEvent or a jQuery.Event when you use jQuery. |
onItemContextMenu
Name | Type | Description |
---|---|---|
component |
The widget's instance. |
|
element |
The widget's container. It is an HTML Element or a jQuery Element when you use jQuery. |
|
model |
The model data. Available only if you use Knockout. |
|
itemData |
The item's data. |
|
itemElement |
The item's container. It is an HTML Element or a jQuery Element when you use jQuery. |
|
itemIndex |
The item's index. |
|
jQueryEvent |
Use 'event' instead. The jQuery event that caused the handler execution. Deprecated in favor of the event field. |
|
event | Event (jQuery or EventObject) |
The event that caused the handler execution. It is a dxEvent or a jQuery.Event when you use jQuery. |
onItemRendered
Name | Type | Description |
---|---|---|
component |
The widget's instance. |
|
element |
The widget's container. It is an HTML Element or a jQuery Element when you use jQuery. |
|
model |
The model data. Available only if you use Knockout. |
|
itemData |
The current item's data. |
|
itemElement |
The item's container. It is an HTML Element or a jQuery Element when you use jQuery. |
|
itemIndex |
The current item's index. |
onOptionChanged
Name | Type | Description |
---|---|---|
name |
The modified option if it belongs to the first level. Otherwise, the first-level option it is nested into. |
|
model |
The model data. Available only if you use Knockout. |
|
element |
The widget's container. It is an HTML Element or a jQuery Element when you use jQuery. |
|
component |
The widget's instance. |
|
fullName |
The path to the modified option that includes all parent options. |
|
value | any |
The modified option's new value. |
onSelectionChanged
Name | Type | Description |
---|---|---|
component |
The widget's instance. |
|
element |
The widget's container. It is an HTML Element or a jQuery Element when you use jQuery. |
|
model |
The model data. Available only if you use Knockout. |
|
addedItems | Array<any> |
The data of the items that have been selected. |
removedItems | Array<any> |
The data of the items whose selection has been canceled. |
onSubmenuHidden
Name | Type | Description |
---|---|---|
component |
The widget's instance. |
|
element |
The widget's container. It is an HTML Element or a jQuery Element when you use jQuery. |
|
model |
The model data. Available only if Knockout is used. |
|
rootItem |
The container of the root menu element. It is an HTML Element or a jQuery Element when you use jQuery. |
onSubmenuHiding
Name | Type | Description |
---|---|---|
component |
The widget's instance. |
|
element |
The widget's container. It is an HTML Element or a jQuery Element when you use jQuery. |
|
model |
The model data. Available only if Knockout is used. |
|
rootItem |
The container of the root menu element. It is an HTML Element or a jQuery Element when you use jQuery. |
|
cancel |
Allows you to cancel submenu hiding. |
onSubmenuShowing
Name | Type | Description |
---|---|---|
component |
The widget's instance. |
|
element |
The widget's container. It is an HTML Element or a jQuery Element when you use jQuery. |
|
model |
The model data. Available only if Knockout is used. |
|
rootItem |
The container of the root menu element. It is an HTML Element or a jQuery Element when you use jQuery. |
onSubmenuShown
Name | Type | Description |
---|---|---|
component |
The widget's instance. |
|
element |
The widget's container. It is an HTML Element or a jQuery Element when you use jQuery. |
|
model |
The model data. Available only if Knockout is used. |
|
rootItem |
The container of the root menu element. It is an HTML Element or a jQuery Element when you use jQuery. |
orientation
Use the Orientation
enum to specify this option when the widget is used as an ASP.NET MVC Control. This enum accepts the following values: Horizontal
and Vertical
.
rtlEnabled
When this option is set to true, the widget text flows from right to left, and the layout of elements is reversed. To switch the entire application/site to the right-to-left representation, assign true to the rtlEnabled field of the object passed to the DevExpress.config(config) method.
- DevExpress.config({
- rtlEnabled: true
- });
See Also
- Right-to-Left Support Demo: DataGrid | Navigation Widgets | Editors
selectedExpr
Specifies the name of the data source item field whose value defines whether or not the corresponding widget items is selected.
selectionMode
To select an item on click and to visually display the selection, set the selectByClick option to true. Note that in this case the selectionMode should be "single".
Use the MenuSelectionMode
enum to specify this option when the widget is used as an ASP.NET MVC Control. This enum accepts the following values: Single
and None
.
showFirstSubmenuMode
If you assign a string that specifies the mode name to this option, the widget will use the default delay value.
- showFirstSubmenuMode: "onHover"
Use the ShowSubmenuMode
enum to specify this option when the widget is used as an ASP.NET MVC Control. This enum accepts the following values: OnHover
and OnClick
.
showSubmenuMode
By default, the secondary-level submenus of the Menu widget are displayed on the same event as the first-level submenu. To set another event for displaying secondary-level submenus, use the showSubmenuMode option. Alternatively, you can change the event on which the first-level submenu is displayed. For this purpose, use the showFirstSubmenuMode option.
Use the ShowSubmenuMode
enum to specify this option when the widget is used as an ASP.NET MVC Control. This enum accepts the following values: OnHover
and OnClick
.
submenuDirection
By default, the first submenu is displayed so that it is visible totally, based on the menu location on the page. Use the submenuDirection option to display the first submenu at the bottom or at the top of a root item when the widget's orientation is horizontal, and to the left or to the right when orientation is vertical.
Use the SubmenuDirection
enum to specify this option when the widget is used as an ASP.NET MVC Control. This enum accepts the following values: LeftOrTop
, RightOrBottom
, and Auto
.
tabIndex
The value of this option will be passed to the tabindex
attribute of the HTML element that underlies the widget.
width
This option accepts a value of one of the following types:
Number
The width in pixels.String
A CSS-accepted measurement of width. For example,"55px"
,"80%"
,"auto"
,"inherit"
.Function
A function returning either of the above. For example:JavaScript- width: function() {
- return window.innerWidth / 1.5;
- }
If you have technical questions, please create a support ticket in the DevExpress Support Center.